package svc

import (
	"applet/app/admin/md"
	"applet/app/db"
	"applet/app/enum"
)

func SelfSupportForSchoolInfo(enterpriseId int) (err error, resp md.SelfSupportForSchoolInfoResp) {
	//1、查询`enterprise`
	enterpriseDb := db.EnterpriseDb{}
	enterpriseDb.Set()
	enterprise, err := enterpriseDb.GetEnterprise(enterpriseId)
	if err != nil {
		return
	}
	resp.Name = enterprise.Name
	resp.Memo = enterprise.Memo
	resp.Kind = enum.EnterpriseKind(enterprise.Kind).String()
	resp.State = enum.EnterpriseState(enterprise.State).String()

	//2、统计 "教师"、 "学生"、 "班级" 数量
	userIdentityDb := db.UserIdentityDb{}
	userIdentityDb.Set(0)
	resp.StudentNum, err = userIdentityDb.CountUserIdentityForEnterprise(enterpriseId, enum.UserIdentityForSelfSupportForStudent)
	if err != nil {
		return
	}
	resp.TeacherNum, err = userIdentityDb.CountUserIdentityForEnterprise(enterpriseId, enum.UserIdentityForSelfSupportForTeacher)
	if err != nil {
		return
	}
	classDb := db.ClassDb{}
	classDb.Set(0)
	resp.ClassNum, err = classDb.CountClassForEnterprise(enterpriseId)
	if err != nil {
		return
	}

	//3、统计 用户人脸信息
	selfSupportForUserFaceInfoDb := db.SelfSupportForUserFaceInfoDb{}
	selfSupportForUserFaceInfoDb.Set(0)
	resp.SchoolFacePassNum, _ = selfSupportForUserFaceInfoDb.CountSchoolFacePassStatus(enterpriseId, "open")
	resp.SchoolFacePaymentNum, _ = selfSupportForUserFaceInfoDb.CountSchoolFacePaymentStatus(enterpriseId, "open")
	resp.SingleSchoolFacePassNum, _ = selfSupportForUserFaceInfoDb.CountCollectFaceType(enterpriseId, 1)
	resp.ConcentrateSchoolFacePassNum, _ = selfSupportForUserFaceInfoDb.CountCollectFaceType(enterpriseId, 2)

	return
}
