package db

import (
	"applet/app/admin/md"
	"applet/app/db/model"
	"applet/app/utils/logx"
	"reflect"
	"xorm.io/xorm"
)

type CentralKitchenForSchoolExportRecordsDb struct {
	Db *xorm.Engine `json:"db"`
}

func (centralKitchenForSchoolExportRecordsDb *CentralKitchenForSchoolExportRecordsDb) Set() { // set方法
	centralKitchenForSchoolExportRecordsDb.Db = Db
}

func (centralKitchenForSchoolExportRecordsDb *CentralKitchenForSchoolExportRecordsDb) GetCentralKitchenForSchoolExportRecords(id int) (m *model.CentralKitchenForSchoolExportRecords, err error) {
	m = new(model.CentralKitchenForSchoolExportRecords)
	has, err := centralKitchenForSchoolExportRecordsDb.Db.Where("id =?", id).Get(m)
	if err != nil {
		return nil, logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return m, nil
}

func (centralKitchenForSchoolExportRecordsDb *CentralKitchenForSchoolExportRecordsDb) GetCentralKitchenForSchoolExportRecordsByMonth(year, month string) (m *model.CentralKitchenForSchoolExportRecords, err error) {
	m = new(model.CentralKitchenForSchoolExportRecords)
	has, err := centralKitchenForSchoolExportRecordsDb.Db.Where("year =? and month =?", year, month).Get(m)
	if err != nil {
		return nil, logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return m, nil
}

func (centralKitchenForSchoolExportRecordsDb *CentralKitchenForSchoolExportRecordsDb) FindCentralKitchenForSchoolExportRecords() (*[]model.CentralKitchenForSchoolExportRecords, error) {
	var m []model.CentralKitchenForSchoolExportRecords
	if err := centralKitchenForSchoolExportRecordsDb.Db.Desc("id").Find(&m); err != nil {
		return nil, logx.Error(err)
	}
	return &m, nil
}

func (centralKitchenForSchoolExportRecordsDb *CentralKitchenForSchoolExportRecordsDb) CentralKitchenForSchoolExportRecordsInsert(m *model.CentralKitchenForSchoolExportRecords) (int, error) {
	_, err := centralKitchenForSchoolExportRecordsDb.Db.InsertOne(m)
	if err != nil {
		return 0, err
	}
	return m.Id, nil
}

func (centralKitchenForSchoolExportRecordsDb *CentralKitchenForSchoolExportRecordsDb) CentralKitchenForSchoolExportRecordsInsertBySession(session *xorm.Session, m *model.CentralKitchenForSchoolExportRecords) (int, error) {
	_, err := session.InsertOne(m)
	if err != nil {
		return 0, err
	}
	return m.Id, nil
}

func (centralKitchenForSchoolExportRecordsDb *CentralKitchenForSchoolExportRecordsDb) CentralKitchenForSchoolExportRecordsDelete(id interface{}) (int64, error) {
	if reflect.TypeOf(id).Kind() == reflect.Slice {
		return Db.In("id", id).Delete(model.CentralKitchenForSchoolExportRecords{})
	} else {
		return Db.Where("id = ?", id).Delete(model.CentralKitchenForSchoolExportRecords{})
	}
}

func (centralKitchenForSchoolExportRecordsDb *CentralKitchenForSchoolExportRecordsDb) CentralKitchenForSchoolExportRecordsUpdateBySession(session *xorm.Session, id interface{}, m *model.CentralKitchenForSchoolExportRecords, forceColums ...string) (int64, error) {
	var (
		affected int64
		err      error
	)
	if forceColums != nil {
		affected, err = session.Where("id=?", id).Cols(forceColums...).Update(m)
	} else {
		affected, err = session.Where("id=?", id).Update(m)
	}
	if err != nil {
		return 0, err
	}
	return affected, nil
}

func (centralKitchenForSchoolExportRecordsDb *CentralKitchenForSchoolExportRecordsDb) CentralKitchenForSchoolExportRecordsList(req md.CentralKitchenForSchoolExportRecordsListReq) (m []model.CentralKitchenForSchoolExportRecords, total int64, err error) {
	sess := centralKitchenForSchoolExportRecordsDb.Db.Desc("id")
	if req.Kind != 0 {
		sess.And("kind =?", req.Kind)
	}
	if req.StartDate != "" {
		sess.And("create_at >=?", req.StartDate)
	}
	if req.EndDate != "" {
		sess.And("create_at <=?", req.EndDate)
	}
	total, err = sess.Limit(req.Limit, (req.Page-1)*req.Limit).FindAndCount(&m)
	if err != nil {
		return
	}
	return
}
